/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package parh1;

/**
 *
 * @author foirabi
 */
public class Parh1 {

    //synchronized - kölcsönös kizárás, csak egy valami használhatja egyszerre
    //ha az adott run objektumra tennénk, mint lentebb, akkor az adott objektumra volt
    //a zár, és így az egyik a másikét nem tudta használni, de ez amúgyse fordult volna elő
    static synchronized void myPrintln(String mitIrki) {
        for (char c : mitIrki.toCharArray()) {
            System.out.print(c);
        }
        System.out.println();
    }
    
    public static void main(String[] args) {
//        new Thread(new Runnable() {
//            @Override
//            public void run () {
//                while (true) {
//                    myPrintln("hello");
//                    //System.out.println("hello");
//                }
//            }
//        }).start();
//        
//        new Thread(new Runnable() {
//            @Override
//            public void run () {
//                while (true) {
//                    myPrintln("vilag");
//                    //System.out.println("vilag");
//                }
//            }
//        }).start();
        
        
        Integer intlock = new Integer(1); //közös zár
        
        Kiiroszal ki1 = new Kiiroszal("hello", intlock);
        Kiiroszal ki2 = new Kiiroszal("vilag", intlock);
        ki1.start();
        ki2.start();
    }
}


class Kiiroszal extends Thread {
    
    String mitIrki;
    Integer intlock;
    
    public Kiiroszal(String mitIrki, Integer intlock) {
        this.mitIrki = mitIrki;
        this.intlock = intlock;
    }
    
    //synchronized void myPrintln() {
    void myPrintln() {
        //synchronized (this) { //ez jelenti azt, hogy a függvény neve elé van írva a sync
        synchronized (intlock) {
            for (char c : mitIrki.toCharArray()) {
                System.out.print(c);
            }
            System.out.println();
        }
    }
    
    @Override
    public void run() {
        for (int i=0; i<10000; ++i) {
            this.myPrintln();
        }
    }
}

// //a régi
//class Kiiroszal extends Thread {
//    
//    String mitIrki;
//    
//    public Kiiroszal(String mitIrki) {
//        this.mitIrki = mitIrki;
//    }
//    
//    synchronized void myPrintln() {
//        for (char c : mitIrki.toCharArray()) {
//            System.out.print(c);
//        }
//        System.out.println();
//    }
//    
//    @Override
//    public void run() {
//        for (int i=0; i<10000; ++i) {
//            this.myPrintln();
//        }
//    }
//}